/// @cond EO_CXX_EO_IMPL

inline void elm::frame::collapse_go(bool collapse_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_frame_collapse_go(::efl::eolian::to_c(collapse_)));
}

inline bool elm::frame::collapse_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_frame_collapse_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::frame::collapse_set(bool collapse_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_frame_collapse_set(::efl::eolian::to_c(collapse_)));
}

inline bool elm::frame::autocollapse_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_frame_autocollapse_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::frame::autocollapse_set(bool autocollapse_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_frame_autocollapse_set(::efl::eolian::to_c(autocollapse_)));
}

inline void eo_cxx::elm::frame::collapse_go(bool collapse_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_frame_collapse_go(::efl::eolian::to_c(collapse_)));
}

inline bool eo_cxx::elm::frame::collapse_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_frame_collapse_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::frame::collapse_set(bool collapse_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_frame_collapse_set(::efl::eolian::to_c(collapse_)));
}

inline bool eo_cxx::elm::frame::autocollapse_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_frame_autocollapse_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::frame::autocollapse_set(bool autocollapse_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_frame_autocollapse_set(::efl::eolian::to_c(autocollapse_)));
}

inline ::eo_cxx::elm::frame::operator ::elm::frame() const
{
   return *static_cast<::elm::frame const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::frame::operator ::elm::frame&()
{
   return *static_cast<::elm::frame*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::frame::operator ::elm::frame const&() const
{
   return *static_cast<::elm::frame const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_frame_collapse_go_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool collapse_)
{
   try
      {
         static_cast<T*>(self->this_)->collapse_go(::efl::eolian::to_cxx<bool>(collapse_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_frame_collapse_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->collapse_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_frame_collapse_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool collapse_)
{
   try
      {
         static_cast<T*>(self->this_)->collapse_set(::efl::eolian::to_cxx<bool>(collapse_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_frame_autocollapse_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->autocollapse_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_frame_autocollapse_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool autocollapse_)
{
   try
      {
         static_cast<T*>(self->this_)->autocollapse_set(::efl::eolian::to_cxx<bool>(autocollapse_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::frame >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::evas::clickable_interface >::template type<T>
   {
      virtual void collapse_go(bool collapse_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_frame_collapse_go(::efl::eolian::to_c(collapse_)));
      }

      virtual bool collapse_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_frame_collapse_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void collapse_set(bool collapse_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_frame_collapse_set(::efl::eolian::to_c(collapse_)));
      }

      virtual bool autocollapse_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_frame_autocollapse_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void autocollapse_set(bool autocollapse_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_frame_autocollapse_set(::efl::eolian::to_c(autocollapse_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::frame >
{
   static constexpr int value = 
#if defined(FRAME_PROTECTED) && defined(FRAME_BETA)
      5
#elif defined(FRAME_PROTECTED)
      5
#elif defined(FRAME_BETA)
      5
#else
      5
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::evas::clickable_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::frame>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_frame_collapse_go_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_frame_collapse_go);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_frame_collapse_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_frame_collapse_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_frame_collapse_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_frame_collapse_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_frame_autocollapse_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_frame_autocollapse_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_frame_autocollapse_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_frame_autocollapse_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::frame >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::clickable_interface>(), &ops[operation_description_class_size< ::elm::frame >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::frame>)
{
   return (ELM_FRAME_CLASS);
}

} } }

/// @endcond

